/*
***************************************************************************
*                                                                         *
* FILE NAME:	idn.cc                                                    *
* COPYRIGHT (C) 1994 BY ABRAXAS SOFTWARE. ALL RIGHTS RESERVED.            *
* AUTHOR:	Shuming Tan                     July 25, 1994             *
* PURPOSE:	This a CodeCheck rule file used to test the predefined    *
*               variables in idn_ group.                                  *
*                                                                         *
***************************************************************************
*/
#include <check.cch>

int i;

if (idn_variable||idn_function)
{
  warn(5000,"%s is declared on line %d of file %s",idn_name(),idn_line,idn_filename());

  if (idn_local)
    warn(5001,"%s has local scope",idn_name());

  if (idn_member)
    warn(5002,"%s has class scope",idn_name());

  if (idn_global)
    warn(5003, "%s has file scope",idn_name());

  if (idn_parameter)
    warn(5004,"%s is a function parameter",idn_name());

  if (idn_function) 
    warn(5005,"%s is an function name",idn_name());

  if (idn_variable)
    warn(5006,"%s is a variable",idn_name());

  if (idn_no_prototype)
    warn(5007,"%s is a function call with no prototype",idn_name());

  if (idn_not_declared)
    warn(5008,"%s is function with no declaration",idn_name());
  
  warn(5009,"%s has base type %d and base name %s",idn_name(),idn_base,idn_base_name());
  
  if (idn_storage_flags&EXTERN_SC)
    warn(5010,"%s has an EXTERN storage flag",idn_name());

  if (idn_storage_flags&STATIC_SC)
    warn(5010,"%s has a STATIC storage flag",idn_name());

  if (idn_storage_flags&TYPEDEF_SC)
    warn(5010,"%s has a TYPEDEF flag",idn_name());

  if (idn_storage_flags&AUTO_SC)
    warn(5010,"%s has an AUTO flag",idn_name());

  if (idn_storage_flags&REGISTER_SC)
    warn(5010,"%s has a REGISTER flag",idn_name());

  if (idn_storage_flags&GLOBAL_SC)
    warn(5010,"%s has a GLOBAL flag",idn_name());

  i=0;
  while (i<=idn_levels)
  {
    warn(5011,"%s is %d at level %d with flag %d",idn_name(),idn_level(i),i,idn_level_flags(i));
    if (idn_level(i)==ARRAY)
      warn(500,"%s demension %d is %d",idn_name(),i,idn_array_dim(i));
    i++;
  }
}

if (idn_constant)
  warn(5012,"%s is an enumerate constant",idn_name());