/*
***************************************************************************
*                                                                         *
* FILE NAME:	mod.c                                                     *
* COPYRIGHT (C) 1994 BY ABRAXAS SOFTWARE. ALL RIGHTS RESERVED.            *
* AUTHOR:	Shuming Tan                     July 26, 1994             *
* PURPOSE:	This file contains the C code used to test CodeCheck      *
*               predefined variables in mod_ group accompanying rule      *
*               file mod.cc                                               *
*                                                                         *
***************************************************************************
*/


/* test mod_macros */
#define M1 123
#define M2 "macro"
#define M3 int m1; \
           int m2;

/* test mod_functions */
static void proc()
{
  int local1,local2;
}

int func(char arg1,char arg2)
{
  return (arg1*arg2);
}

/* define global simple variables for test mod_simple */
/*test mod_static */
static int i1,i2,i3;
char c1,c2;
float f1,f2,f3;

/* test mod_extern */
extern short s1,s2,s3;

long *l;  /* should this be a simple variable? */

/* test mod_array mod_aggr */
char array1[10][20];
int array2[75];

/* test mod_members */
struct strct1
{
  int field11;
  char *field12;
  union strct2
  {
    float field21;
    short field22;
  } field13;
};

struct strct1 rec1,rec2;
struct strct1 &rec3=rec1;

class strct3
{
  static int field31;
  double *field32;
public:
  unsigned long field33;
  void field34(int);
  int field35(void);
};

strct3 rec4,*rec5;


main()
{
  /* define local simple variables */
  /* to see if they are covered by mod_simple */

  int i4,i5;
  static char c3,c4,c5;
  extern short s4,s5;

  /* define a structure within a function */
  struct strct4
  {
    strct3 field41;
    char *field42;
    signed int field43;
  }  rec6;

  /* test mod_decisions */
  /* there should be 1 implicit binary decision point here */
  for (i4=i1;i4<M1&&i4>i2;i4++)
  {
     i4+=i5;
     continue;
  }
  
  /* there should be 2 implicit binary decision point here */
  switch (c1)
  {
    /* syntax error to test mod_warnings */
    case 'a','b': c3=c1;
                  break;
    case 'd':     c4=c1;
                  break;
    default:      c5=c1;
  }
  
  /* there are two binary decisiuon point here */
  if (c2>c1) print("C2>C1");  /* use a undefined identifier to test mod_warnings */
  else
    if (c2*2<c1) c2=c1;
    else c1=c2;

  /* there is 1 binary decision point here */
  if (1) s4=100;

  /* there is 1 implicit decision point here */
  while (1) { };
}
